#!/bin/sh

# Usage:
# ./test-multiway-merge.sh
# ./test-multiway-merge.sh d
# ./test-multiway-merge.sh d e
# ./test-multiway-merge.sh d e f
# ...

GIT=$PWD/git
#GIT=git

mkbranch () {
    branch=$1
    "$GIT" branch "$branch" master
    "$GIT" checkout "$branch"
    echo "$branch" > "$branch"
    "$GIT" add "$branch"
    "$GIT" commit -m "$branch"
}

mkdir -p log-format-test
rm -rf log-format-test/* log-format-test/.*
cd log-format-test


"$GIT" init
echo 0 > foo
"$GIT" add foo
"$GIT" commit -m 0

mkbranch a
mkbranch b
for branch ; do
    mkbranch $branch
done

"$GIT" checkout master
echo 1 > foo
"$GIT" commit -am 1

# The name of this branch affects the outcome
# e.g. calling it "x" doesn't trip the bug (!)
mkbranch c

"$GIT" branch m master
"$GIT" checkout m
"$GIT" merge -m "merge a b $*" a b "$@"

valgrind "$GIT" log --oneline --graph --all
